<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>github-ref-guide</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h2 id="table-of-contents">Table of Contents</h2>
    <ul>
      <li>
        <a href="#github">GitHub</a>
        <ul>
          <li><a href="#ignore-whitespace">Ignore Whitespace</a></li>
          <li><a href="#adjust-tab-space">Adjust Tab Space</a></li>
          <li><a href="#cloning-a-repository">Cloning a Repository</a></li>
          <li>
            <a href="#branch">Branch</a>
            <ul>
              <li>
                <a href="#compare-all-branches-to-another-branch"
                  >Compare all Branches to Another Branch</a
                >
              </li>
              <li><a href="#comparing-branches">Comparing Branches</a></li>
              <li>
                <a href="#compare-branches-across-forked-repositories"
                  >Compare Branches across Forked Repositories</a
                >
              </li>
            </ul>
          </li>
          <li><a href="#gists">Gists</a></li>
          <li><a href="#gitio">Git.io</a></li>
          <li><a href="#keyboard-shortcuts">Keyboard Shortcuts</a></li>
          <li>
            <a href="#line-highlighting-in-repositories"
              >Line Highlighting in Repositories</a
            >
          </li>
          <li>
            <a href="#closing-issues-via-commit-messages"
              >Closing Issues via Commit Messages</a
            >
          </li>
          <li><a href="#cross-link-issues">Cross-Link Issues</a></li>
          <li><a href="#locking-conversations">Locking Conversations</a></li>
          <li>
            <a href="#ci-status-on-pull-requests">CI Status on Pull Requests</a>
          </li>
          <li><a href="#filters">Filters</a></li>
          <li>
            <a href="#syntax-highlighting-in-markdown-files"
              >Syntax Highlighting in Markdown Files</a
            >
          </li>
          <li><a href="#emojis">Emojis</a></li>
          <li>
            <a href="#imagesgifs">Images/GIFs</a>
            <ul>
              <li>
                <a href="#embedding-images-in-github-wiki"
                  >Embedding Images in GitHub Wiki</a
                >
              </li>
            </ul>
          </li>
          <li><a href="#quick-quoting">Quick Quoting</a></li>
          <li>
            <a href="#pasting-clipboard-image-to-comments"
              >Pasting Clipboard Image to Comments</a
            >
          </li>
          <li><a href="#quick-licensing">Quick Licensing</a></li>
          <li>
            <a href="#task-lists">Task Lists</a>
            <ul>
              <li>
                <a href="#task-lists-in-markdown-documents"
                  >Task Lists in Markdown Documents</a
                >
              </li>
            </ul>
          </li>
          <li><a href="#relative-links">Relative Links</a></li>
          <li>
            <a href="#metadata-and-plugin-support-for-github-pages"
              >Metadata and Plugin Support for GitHub Pages</a
            >
          </li>
          <li>
            <a href="#viewing-yaml-metadata-in-your-documents"
              >Viewing YAML Metadata in your Documents</a
            >
          </li>
          <li><a href="#rendering-tabular-data">Rendering Tabular Data</a></li>
          <li><a href="#rendering-pdf">Rendering PDF</a></li>
          <li><a href="#revert-a-pull-request">Revert a Pull Request</a></li>
          <li>
            <a href="#diffs">Diffs</a>
            <ul>
              <li><a href="#rendered-prose-diffs">Rendered Prose Diffs</a></li>
              <li><a href="#diffable-maps">Diffable Maps</a></li>
              <li>
                <a href="#expanding-context-in-diffs"
                  >Expanding Context in Diffs</a
                >
              </li>
              <li>
                <a href="#diff-or-patch-of-pull-request"
                  >Diff or Patch of Pull Request</a
                >
              </li>
              <li>
                <a href="#rendering-and-diffing-images"
                  >Rendering and diffing images</a
                >
              </li>
            </ul>
          </li>
          <li><a href="#hub">Hub</a></li>
          <li>
            <a href="#contribution-guidelines">Contribution Guidelines</a>
            <ul>
              <li><a href="#contributing-file">CONTRIBUTING file</a></li>
              <li><a href="#issue_template-file">ISSUE_TEMPLATE file</a></li>
              <li>
                <a href="#pull_request_template-file"
                  >PULL_REQUEST_TEMPLATE file</a
                >
              </li>
            </ul>
          </li>
          <li><a href="#octicons">Octicons</a></li>
          <li>
            <a href="#github-student-developer-pack"
              >GitHub Student Developer Pack</a
            >
          </li>
          <li>
            <a href="#github-resources">GitHub Resources</a>
            <ul>
              <li><a href="#github-talks">GitHub Talks</a></li>
            </ul>
          </li>
          <li><a href="#ssh-keys">SSH keys</a></li>
          <li><a href="#profile-image">Profile Image</a></li>
          <li><a href="#repository-templates">Repository Templates</a></li>
        </ul>
      </li>
      <li>
        <a href="#git">Git</a>
        <ul>
          <li>
            <a href="#remove-all-deleted-files-from-the-working-tree"
              >Remove All Deleted Files from the Working Tree</a
            >
          </li>
          <li><a href="#previous-branch">Previous Branch</a></li>
          <li><a href="#stripspace">Stripspace</a></li>
          <li>
            <a href="#checking-out-pull-requests">Checking out Pull Requests</a>
          </li>
          <li><a href="#empty-commits">Empty Commits</a></li>
          <li><a href="#styled-git-status">Styled Git Status</a></li>
          <li><a href="#styled-git-log">Styled Git Log</a></li>
          <li><a href="#git-query">Git Query</a></li>
          <li><a href="#git-grep">Git Grep</a></li>
          <li><a href="#merged-branches">Merged Branches</a></li>
          <li><a href="#fixup-and-autosquash">Fixup and Autosquash</a></li>
          <li>
            <a href="#web-server-for-browsing-local-repositories"
              >Web Server for Browsing Local Repositories</a
            >
          </li>
          <li>
            <a href="#git-configurations">Git Configurations</a>
            <ul>
              <li><a href="#aliases">Aliases</a></li>
              <li><a href="#auto-correct">Auto-Correct</a></li>
              <li><a href="#color">Color</a></li>
            </ul>
          </li>
          <li>
            <a href="#git-resources">Git Resources</a>
            <ul>
              <li><a href="#git-books">Git Books</a></li>
              <li><a href="#git-videos">Git Videos</a></li>
              <li><a href="#git-articles">Git Articles</a></li>
            </ul>
          </li>
        </ul>
      </li>
    </ul>
    <h2 id="github">GitHub</h2>
    <h3 id="ignore-whitespace">Ignore Whitespace</h3>
    <p>
      Adding <code>?w=1</code> to any diff URL will remove any changes only in
      whitespace, enabling you to see only the code that has changed.
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/797184940defadec00393e6559b835358a863eeb/68747470733a2f2f6769746875622d696d616765732e73332e616d617a6f6e6177732e636f6d2f626c6f672f323031312f736563726574732f776869746573706163652e706e67"
        alt="Diff without whitespace"
      />
      <figcaption>Diff without whitespace</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/967-github-secrets"
        ><em>Read more about GitHub secrets.</em></a
      >
    </p>
    <h3 id="adjust-tab-space">Adjust Tab Space</h3>
    <p>
      Adding <code>?ts=4</code> to a diff or file URL will display tab
      characters as 4 spaces wide instead of the default 8. The number after
      <code>ts</code> can be adjusted to suit your preference. This does not
      work on Gists, or raw file views, but a
      <a
        href="https://chrome.google.com/webstore/detail/tab-size-on-github/ofjbgncegkdemndciafljngjbdpfmbkn"
        >Chrome extension</a
      >
      can automate this.
    </p>
    <p>Here is a Go source file before adding <code>?ts=4</code>:</p>
    <figure>
      <img
        src="http://i.imgur.com/GIT1Fr0.png"
        alt="Before, tab space example"
      />
      <figcaption>Before, tab space example</figcaption>
    </figure>
    <p>…and this is after adding <code>?ts=4</code>:</p>
    <figure>
      <img
        src="http://i.imgur.com/70FL4H9.png"
        alt="After, tab space example"
      />
      <figcaption>After, tab space example</figcaption>
    </figure>
    <h3 id="commit-history-by-author">Commit History by Author</h3>
    <pre><code></code></pre>
    <figure>
      <img src="http://i.imgur.com/S7AE29b.png" alt="DHH commit history" />
      <figcaption>DHH commit history</figcaption>
    </figure>
    <p>
      <a
        href="https://help.github.com/articles/differences-between-commit-views/"
        ><em>Read more about the differences between commits views.</em></a
      >
    </p>
    <h3 id="cloning-a-repository">Cloning a Repository</h3>
    <p>
      When cloning a repository the <code>.git</code> can be left off the end.
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1">$ <span class="fu">git</span> clone https://github.com/tiimgreen/github-cheat-sheet</a></code></pre>
    </div>
    <p>
      <a href="http://git-scm.com/docs/git-clone"
        ><em>Read more about the Git <code>clone</code> command.</em></a
      >
    </p>
    <h3 id="branch">Branch</h3>
    <h4 id="compare-all-branches-to-another-branch">
      Compare all Branches to Another Branch
    </h4>
    <p>
      If you go to the repo’s
      <a href="https://github.com/tiimgreen/github-cheat-sheet/branches"
        >Branches</a
      >
      page, next to the Commits button:
    </p>
    <pre><code>https://github.com/{user}/{repo}/branches</code></pre>
    <p>
      … you would see a list of all branches which are not merged into the main
      branch.
    </p>
    <p>
      From here you can access the compare page or delete a branch with a click
      of a button.
    </p>
    <figure>
      <img
        src="http://i.imgur.com/0FEe30z.png"
        alt="Compare branches not merged into master in rails/rails repo - https://github.com/rails/rails/branches"
      />
      <figcaption>
        Compare branches not merged into master in rails/rails repo -
        https://github.com/rails/rails/branches
      </figcaption>
    </figure>
    <h4 id="comparing-branches">Comparing Branches</h4>
    <p>To use GitHub to compare branches, change the URL to look like this:</p>
    <pre><code>https://github.com/{user}/{repo}/compare/{range}</code></pre>
    <p>where <code>{range} = master...4-1-stable</code></p>
    <p>For example:</p>
    <pre><code>https://github.com/rails/rails/compare/master...4-1-stable</code></pre>
    <figure>
      <img
        src="http://i.imgur.com/tIRCOsK.png"
        alt="Rails branch compare example"
      />
      <figcaption>Rails branch compare example</figcaption>
    </figure>
    <p><code>{range}</code> can be changed to things like:</p>
    <pre><code>https://github.com/rails/rails/compare/master@{1.day.ago}...master
https://github.com/rails/rails/compare/master@{2014-10-04}...master</code></pre>
    <p>
      <em>Here, dates are in the format <code>YYYY-MM-DD</code></em>
    </p>
    <figure>
      <img src="http://i.imgur.com/5dtzESz.png" alt="Another compare example" />
      <figcaption>Another compare example</figcaption>
    </figure>
    <p>
      Branches can also be compared in <code>diff</code> and
      <code>patch</code> views:
    </p>
    <pre><code>https://github.com/rails/rails/compare/master...4-1-stable.diff
https://github.com/rails/rails/compare/master...4-1-stable.patch</code></pre>
    <p>
      <a href="https://help.github.com/articles/comparing-commits-across-time/"
        ><em>Read more about comparing commits across time.</em></a
      >
    </p>
    <h4 id="compare-branches-across-forked-repositories">
      Compare Branches across Forked Repositories
    </h4>
    <p>
      To use GitHub to compare branches across forked repositories, change the
      URL to look like this:
    </p>
    <pre><code>https://github.com/{user}/{repo}/compare/{foreign-user}:{branch}...{own-branch}</code></pre>
    <p>For example:</p>
    <pre><code>https://github.com/rails/rails/compare/byroot:master...master</code></pre>
    <figure>
      <img src="http://i.imgur.com/Q1W6qcB.png" alt="Forked branch compare" />
      <figcaption>Forked branch compare</figcaption>
    </figure>
    <h3 id="gists">Gists</h3>
    <p>
      <a href="https://gist.github.com/">Gists</a> are an easy way to work with
      small bits of code without creating a fully fledged repository.
    </p>
    <figure>
      <img src="http://i.imgur.com/VkKI1LC.png?1" alt="Gist" />
      <figcaption>Gist</figcaption>
    </figure>
    <p>
      Add <code>.pibb</code> to the end of any Gist URL (<a
        href="https://gist.github.com/tiimgreen/10545817.pibb"
        >like this</a
      >) in order to get the <em>HTML-only</em> version suitable for embedding
      in any other site.
    </p>
    <p>
      Gists can be treated as a repository so they can be cloned like any other:
    </p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1">$ <span class="fu">git</span> clone https://gist.github.com/tiimgreen/10545817</a></code></pre>
    </div>
    <figure>
      <img src="http://i.imgur.com/BcFzabp.png" alt="Gists" />
      <figcaption>Gists</figcaption>
    </figure>
    <p>This means you also can modify and push updates to Gists:</p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb11-1" title="1">$ <span class="fu">git</span> commit</a>
<a class="sourceLine" id="cb11-2" title="2">$ <span class="fu">git</span> push</a>
<a class="sourceLine" id="cb11-3" title="3"><span class="ex">Username</span> for <span class="st">&#39;https://gist.github.com&#39;</span>:</a>
<a class="sourceLine" id="cb11-4" title="4"><span class="ex">Password</span> for <span class="st">&#39;https://tiimgreen@gist.github.com&#39;</span>:</a></code></pre>
    </div>
    <p>
      However, Gists do not support directories. All files need to be added to
      the repository root.
      <a href="https://help.github.com/articles/creating-gists/"
        ><em>Read more about creating Gists.</em></a
      >
    </p>
    <h3 id="git.io">Git.io</h3>
    <p>
      <a href="http://git.io">Git.io</a> is a simple URL shortener for GitHub.
    </p>
    <figure>
      <img src="http://i.imgur.com/6JUfbcG.png?1" alt="Git.io" />
      <figcaption>Git.io</figcaption>
    </figure>
    <p>You can also use it via pure HTTP using Curl:</p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1">$ <span class="ex">curl</span> -i http://git.io -F <span class="st">&quot;url=https://github.com/...&quot;</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="ex">HTTP/1.1</span> 201 Created</a>
<a class="sourceLine" id="cb12-3" title="3"><span class="ex">Location</span>: http://git.io/abc123</a>
<a class="sourceLine" id="cb12-4" title="4"></a>
<a class="sourceLine" id="cb12-5" title="5">$ <span class="ex">curl</span> -i http://git.io/abc123</a>
<a class="sourceLine" id="cb12-6" title="6"><span class="ex">HTTP/1.1</span> 302 Found</a>
<a class="sourceLine" id="cb12-7" title="7"><span class="ex">Location</span>: https://github.com/...</a></code></pre>
    </div>
    <p>
      <a href="https://github.com/blog/985-git-io-github-url-shortener"
        ><em>Read more about Git.io.</em></a
      >
    </p>
    <h3 id="keyboard-shortcuts">Keyboard Shortcuts</h3>
    <p>
      When on a repository page, keyboard shortcuts allow you to navigate
      easily.
    </p>
    <ul>
      <li>Pressing <code>t</code> will bring up a file explorer.</li>
      <li>Pressing <code>w</code> will bring up the branch selector.</li>
      <li>
        Pressing <code>s</code> will focus the search field for the current
        repository. Pressing ↓ to select the “All GitHub” option changes the
        field to search all of GitHub.
      </li>
      <li>Pressing <code>l</code> will edit labels on existing Issues.</li>
      <li>
        Pressing <code>y</code> <strong>when looking at a file</strong> (e.g.,
        <code
          >https://github.com/tiimgreen/github-cheat-sheet/blob/master/README.md</code
        >) will change your URL to one which, in effect, freezes the page you
        are looking at. If this code changes, you will still be able to see what
        you saw at that current time.
      </li>
    </ul>
    <p>
      To see all of the shortcuts for the current page press <code>?</code>:
    </p>
    <figure>
      <img src="http://i.imgur.com/y5ZfNEm.png" alt="Keyboard shortcuts" />
      <figcaption>Keyboard shortcuts</figcaption>
    </figure>
    <p>
      <a href="https://help.github.com/articles/search-syntax/"
        >Read more about search syntax you can use.</a
      >
    </p>
    <h3 id="line-highlighting-in-repositories">
      Line Highlighting in Repositories
    </h3>
    <p>
      Either adding, e.g., <code>#L52</code> to the end of a code file URL or
      simply clicking the line number will highlight that line number.
    </p>
    <p>
      It also works with ranges, e.g., <code>#L53-L60</code>, to select ranges,
      hold <code>shift</code> and click two lines:
    </p>
    <pre><code>https://github.com/rails/rails/blob/master/activemodel/lib/active_model.rb#L53-L60</code></pre>
    <figure>
      <img src="http://i.imgur.com/8AhjrCz.png" alt="Line Highlighting" />
      <figcaption>Line Highlighting</figcaption>
    </figure>
    <h3 id="closing-issues-via-commit-messages">
      Closing Issues via Commit Messages
    </h3>
    <p>
      If a particular commit fixes an issue, any of the keywords
      <code>fix/fixes/fixed</code>, <code>close/closes/closed</code> or
      <code>resolve/resolves/resolved</code>, followed by the issue number, will
      close the issue once it is committed to the repository’s default branch.
    </p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb14-1" title="1">$ <span class="fu">git</span> commit -m <span class="st">&quot;Fix screwup, fixes #12&quot;</span></a></code></pre>
    </div>
    <p>This closes the issue and references the closing commit.</p>
    <figure>
      <img src="http://i.imgur.com/Uh1gZdx.png" alt="Closing Repo" />
      <figcaption>Closing Repo</figcaption>
    </figure>
    <p>
      <a
        href="https://help.github.com/articles/closing-issues-via-commit-messages/"
        ><em>Read more about closing Issues via commit messages.</em></a
      >
    </p>
    <h3 id="cross-link-issues">Cross-Link Issues</h3>
    <p>
      If you want to link to another issue in the same repository, simply type
      hash <code>#</code> then the issue number, and it will be auto-linked.
    </p>
    <p>
      To link to an issue in another repository,
      <code>{user}/{repo}#ISSUE_NUMBER</code>, e.g.,
      <code>tiimgreen/toc#12</code>.
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/447e39ab8d96b553cadc8d31799100190df230a8/68747470733a2f2f6769746875622d696d616765732e73332e616d617a6f6e6177732e636f6d2f626c6f672f323031312f736563726574732f7265666572656e6365732e706e67"
        alt="Cross-Link Issues"
      />
      <figcaption>Cross-Link Issues</figcaption>
    </figure>
    <h3 id="locking-conversations">Locking Conversations</h3>
    <p>
      Pull Requests and Issues can now be locked by owners or collaborators of
      the repo.
    </p>
    <figure>
      <img
        src="https://cloud.githubusercontent.com/assets/2723/3221693/bf54dd44-f00d-11e3-8eb6-bb51e825bc2c.png"
        alt="Lock conversation"
      />
      <figcaption>Lock conversation</figcaption>
    </figure>
    <p>
      This means that users who are not collaborators on the project will no
      longer be able to comment.
    </p>
    <figure>
      <img
        src="https://cloud.githubusercontent.com/assets/2723/3221775/d6e513b0-f00e-11e3-9721-2131cb37c906.png"
        alt="Comments locked"
      />
      <figcaption>Comments locked</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1847-locking-conversations"
        ><em>Read more about locking conversations.</em></a
      >
    </p>
    <h3 id="ci-status-on-pull-requests">CI Status on Pull Requests</h3>
    <p>
      If set up correctly, every time you receive a Pull Request,
      <a href="https://travis-ci.org/">Travis CI</a> will build that Pull
      Request just like it would every time you make a new commit. Read more
      about how to
      <a href="http://docs.travis-ci.com/user/getting-started/"
        >get started with Travis CI</a
      >.
    </p>
    <p>
      <a href="https://github.com/octokit/octokit.rb/pull/452"
        ><img
          src="https://cloud.githubusercontent.com/assets/1687642/2700187/3a88838c-c410-11e3-9a46-e65e2a0458cd.png"
          alt="Travis CI status"
      /></a>
    </p>
    <p>
      <a href="https://github.com/blog/1227-commit-status-api"
        ><em>Read more about the commit status API.</em></a
      >
    </p>
    <h3 id="filters">Filters</h3>
    <p>Both issues and pull requests allow filtering in the user interface.</p>
    <p>
      For the Rails repo: https://github.com/rails/rails/issues, the following
      filter is built by selecting the label “activerecord”:
    </p>
    <p><code>is:issue label:activerecord</code></p>
    <p>But, you can also find all issues that are NOT labeled activerecord:</p>
    <p><code>is:issue -label:activerecord</code></p>
    <p>Additionally, this also works for pull requests:</p>
    <p><code>is:pr -label:activerecord</code></p>
    <p>
      Github has tabs for displaying open or closed issues and pull requests but
      you can also see merged pull requests. Just put the following in the
      filter:
    </p>
    <p><code>is:merged</code></p>
    <p>
      <a href="https://help.github.com/articles/searching-issues/"
        ><em>Read more about searching issues.</em></a
      >
    </p>
    <p>Finally, github now allows you to filter by the Status API’s status.</p>
    <p>Pull requests with only successful statuses:</p>
    <p><code>status:success</code></p>
    <p>
      <a href="https://github.com/blog/2014-filter-pull-requests-by-status"
        ><em>Read more about searching on the Status API.</em></a
      >
    </p>
    <h3 id="syntax-highlighting-in-markdown-files">
      Syntax Highlighting in Markdown Files
    </h3>
    <p>
      For example, to syntax highlight Ruby code in your Markdown files write:
    </p>
    <pre><code>```ruby
require &#39;tabbit&#39;
table = Tabbit.new(&#39;Name&#39;, &#39;Email&#39;)
table.add_row(&#39;Tim Green&#39;, &#39;tiimgreen@gmail.com&#39;)
puts table.to_s
```</code></pre>
    <p>This will produce:</p>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode ruby"
      ><code class="sourceCode ruby"><a class="sourceLine" id="cb16-1" title="1">require <span class="st">&#39;tabbit&#39;</span></a>
<a class="sourceLine" id="cb16-2" title="2">table = <span class="dt">Tabbit</span>.new(<span class="st">&#39;Name&#39;</span>, <span class="st">&#39;Email&#39;</span>)</a>
<a class="sourceLine" id="cb16-3" title="3">table.add_row(<span class="st">&#39;Tim Green&#39;</span>, <span class="st">&#39;tiimgreen@gmail.com&#39;</span>)</a>
<a class="sourceLine" id="cb16-4" title="4">puts table.to_s</a></code></pre>
    </div>
    <p>
      GitHub uses <a href="https://github.com/github/linguist">Linguist</a> to
      perform language detection and syntax highlighting. You can find out which
      keywords are valid by perusing the
      <a
        href="https://github.com/github/linguist/blob/master/lib/linguist/languages.yml"
        >languages YAML file</a
      >.
    </p>
    <p>
      <a href="https://help.github.com/articles/github-flavored-markdown/"
        ><em>Read more about GitHub Flavored Markdown.</em></a
      >
    </p>
    <h3 id="emojis">Emojis</h3>
    <p>
      Emojis can be added to Pull Requests, Issues, commit messages, repository
      descriptions, etc. using <code>:name_of_emoji:</code>.
    </p>
    <p>
      The full list of supported Emojis on GitHub can be found at
      <a href="http://www.emoji-cheat-sheet.com/">emoji-cheat-sheet.com</a> or
      <a href="https://github.com/scotch-io/All-Github-Emoji-Icons"
        >scotch-io/All-Github-Emoji-Icons</a
      >. A handy emoji search engine can be found at
      <a href="http://emoji.muan.co/">emoji.muan.co</a>.
    </p>
    <p>The top 5 used Emojis on GitHub are:</p>
    <ol type="1">
      <li><code>:shipit:</code></li>
      <li><code>:sparkles:</code></li>
      <li><code>:-1:</code></li>
      <li><code>:+1:</code></li>
      <li><code>:clap:</code></li>
    </ol>
    <h3 id="imagesgifs">Images/GIFs</h3>
    <p>Images and GIFs can be added to comments, READMEs etc.:</p>
    <pre><code>![Alt Text](http://www.sheawong.com/wp-content/uploads/2013/08/keephatin.gif)</code></pre>
    <p>Raw images from the repo can be used by calling them directly.:</p>
    <pre><code>![Alt Text](https://github.com/{user}/{repo}/raw/master/path/to/image.gif)</code></pre>
    <figure>
      <img
        src="http://www.sheawong.com/wp-content/uploads/2013/08/keephatin.gif"
        alt="Peter don’t care"
      />
      <figcaption>Peter don’t care</figcaption>
    </figure>
    <p>
      All images are cached on GitHub, so if your host goes down, the image will
      remain available.
    </p>
    <h4 id="embedding-images-in-github-wiki">
      Embedding Images in GitHub Wiki
    </h4>
    <p>
      There are multiple ways of embedding images in Wiki pages. There’s the
      standard Markdown syntax (shown above). But there’s also a syntax that
      allows things like specifying the height or width of the image:
    </p>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode markdown"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb19-1" title="1">[[ http://www.sheawong.com/wp-content/uploads/2013/08/keephatin.gif | height = 100px ]]</a></code></pre>
    </div>
    <p>Which produces:</p>
    <figure>
      <img src="http://i.imgur.com/J5bMf7S.png" alt="Just a screenshot" />
      <figcaption>Just a screenshot</figcaption>
    </figure>
    <h3 id="quick-quoting">Quick Quoting</h3>
    <p>
      When on a comment thread and you want to quote something someone
      previously said, highlight the text and press <code>r</code>, this will
      copy it into your text box in the block-quote format.
    </p>
    <figure>
      <img
        src="https://f.cloud.github.com/assets/296432/124483/b0fa6204-6ef0-11e2-83c3-256c37fa7abc.gif"
        alt="Quick Quote"
      />
      <figcaption>Quick Quote</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1399-quick-quotes"
        ><em>Read more about quick quoting.</em></a
      >
    </p>
    <h3 id="pasting-clipboard-image-to-comments">
      Pasting Clipboard Image to Comments
    </h3>
    <p><em>(Works on Chrome browsers only)</em></p>
    <p>
      After taking a screenshot and adding it to the clipboard (mac:
      <code>cmd-ctrl-shift-4</code>), you can simply paste (<code
        >cmd-v / ctrl-v</code
      >) the image into the comment section and it will be auto-uploaded to
      github.
    </p>
    <figure>
      <img
        src="https://cloud.githubusercontent.com/assets/39191/5794265/39c9b65a-9f1b-11e4-9bc7-04e41f59ea5f.png"
        alt="Pasting Clipboard Image to Comments"
      />
      <figcaption>Pasting Clipboard Image to Comments</figcaption>
    </figure>
    <p>
      <a href="https://help.github.com/articles/issue-attachments/"
        ><em>Read more about issue attachments.</em></a
      >
    </p>
    <h3 id="quick-licensing">Quick Licensing</h3>
    <p>
      When creating a repository, GitHub gives you the option of adding in a
      pre-made license:
    </p>
    <figure>
      <img src="http://i.imgur.com/Chqj4Fg.png" alt="License" />
      <figcaption>License</figcaption>
    </figure>
    <p>
      You can also add them to existing repositories by creating a new file
      through the web interface. When the name <code>LICENSE</code> is typed in
      you will get an option to use a template:
    </p>
    <figure>
      <img src="http://i.imgur.com/fTjQict.png" alt="License" />
      <figcaption>License</figcaption>
    </figure>
    <p>Also works for <code>.gitignore</code>.</p>
    <p>
      <a href="https://help.github.com/articles/open-source-licensing/"
        ><em>Read more about open source licensing.</em></a
      >
    </p>
    <h3 id="task-lists">Task Lists</h3>
    <p>
      In Issues and Pull requests check boxes can be added with the following
      syntax (notice the space):
    </p>
    <pre><code>- [ ] Be awesome
- [ ] Prepare dinner
  - [ ] Research recipe
  - [ ] Buy ingredients
  - [ ] Cook recipe
- [ ] Sleep</code></pre>
    <figure>
      <img src="http://i.imgur.com/jJBXhsY.png" alt="Task List" />
      <figcaption>Task List</figcaption>
    </figure>
    <p>When they are clicked, they will be updated in the pure Markdown:</p>
    <pre><code>- [x] Be awesome
- [ ] Prepare dinner
  - [x] Research recipe
  - [x] Buy ingredients
  - [ ] Cook recipe
- [ ] Sleep</code></pre>
    <p>
      <a href="https://help.github.com/articles/writing-on-github/#task-lists"
        ><em>Read more about task lists.</em></a
      >
    </p>
    <h4 id="task-lists-in-markdown-documents">
      Task Lists in Markdown Documents
    </h4>
    <p>
      In full Markdown documents <strong>read-only</strong> checklists can now
      be added using the following syntax:
    </p>
    <pre><code>- [ ] Mercury
- [x] Venus
- [x] Earth
  - [x] Moon
- [x] Mars
  - [ ] Deimos
  - [ ] Phobos</code></pre>
    <ul>
      <li>[ ] Mercury</li>
      <li>[x] Venus</li>
      <li>
        [x] Earth
        <ul>
          <li>[x] Moon</li>
        </ul>
      </li>
      <li>
        [x] Mars
        <ul>
          <li>[ ] Deimos</li>
          <li>[ ] Phobos</li>
        </ul>
      </li>
    </ul>
    <p>
      <a
        href="https://github.com/blog/1825-task-lists-in-all-markdown-documents"
        ><em>Read more about task lists in markdown documents.</em></a
      >
    </p>
    <h3 id="relative-links">Relative Links</h3>
    <p>
      Relative links are recommended in your Markdown files when linking to
      internal content.
    </p>
    <div class="sourceCode" id="cb23">
      <pre
        class="sourceCode markdown"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb23-1" title="1"><span class="ot">[Link to a header](#awesome-section)</span></a>
<a class="sourceLine" id="cb23-2" title="2"><span class="ot">[Link to a file](docs/readme)</span></a></code></pre>
    </div>
    <p>
      Absolute links have to be updated whenever the URL changes (e.g.,
      repository renamed, username changed, project forked). Using relative
      links makes your documentation easily stand on its own.
    </p>
    <p>
      <a href="https://help.github.com/articles/relative-links-in-readmes/"
        ><em>Read more about relative links.</em></a
      >
    </p>
    <h3 id="metadata-and-plugin-support-for-github-pages">
      Metadata and Plugin Support for GitHub Pages
    </h3>
    <p>
      Within Jekyll pages and posts, repository information is available within
      the <code>site.github</code> namespace, and can be displayed, for example,
      using <code>{{ site.github.project_title }}</code>.
    </p>
    <p>
      The Jemoji and jekyll-mentions plugins enable
      <a href="#emojis">emoji</a> and
      <span class="citation" data-cites="mentions">[@mentions]</span
      >(https://github.com/blog/821) in your Jekyll posts and pages to work just
      like you’d expect when interacting with a repository on GitHub.com.
    </p>
    <p>
      <a
        href="https://github.com/blog/1797-repository-metadata-and-plugin-support-for-github-pages"
        ><em
          >Read more about repository metadata and plugin support for GitHub
          Pages.</em
        ></a
      >
    </p>
    <h3 id="viewing-yaml-metadata-in-your-documents">
      Viewing YAML Metadata in your Documents
    </h3>
    <p>
      Many blogging websites, like
      <a href="http://jekyllrb.com/">Jekyll</a> with
      <a href="https://pages.github.com">GitHub Pages</a>, depend on some
      YAML-formatted metadata at the beginning of your post. GitHub will render
      this metadata as a horizontal table, for easier reading
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/47245aa16728e242f74a9a324ce0d24c0b916075/68747470733a2f2f662e636c6f75642e6769746875622e636f6d2f6173736574732f36343035302f313232383236372f65303439643063362d323761302d313165332d396464382d6131636432323539393334342e706e67"
        alt="YAML metadata"
      />
      <figcaption>YAML metadata</figcaption>
    </figure>
    <p>
      <a
        href="https://github.com/blog/1647-viewing-yaml-metadata-in-your-documents"
        ><em>Read more about viewing YAML metadata in your documents.</em></a
      >
    </p>
    <h3 id="rendering-tabular-data">Rendering Tabular Data</h3>
    <p>
      GitHub supports rendering tabular data in the form of
      <code>.csv</code> (comma-separated) and <code>.tsv</code> (tab-separated)
      files.
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/1b6dd0157ffb45d9939abf14233a0cb13b3b4dfe/68747470733a2f2f662e636c6f75642e6769746875622e636f6d2f6173736574732f3238323735392f3937363436322f33323038336463652d303638642d313165332d393262322d3566323863313061353035392e706e67"
        alt="Tabular data"
      />
      <figcaption>Tabular data</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1601-see-your-csvs"
        ><em>Read more about rendering tabular data.</em></a
      >
    </p>
    <h3 id="rendering-pdf">Rendering PDF</h3>
    <p>GitHub supports rendering PDF:</p>
    <figure>
      <img
        src="https://cloud.githubusercontent.com/assets/1000669/7492902/f8493160-f42e-11e4-8cea-1cb4f02757e7.png"
        alt="PDF"
      />
      <figcaption>PDF</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1974-pdf-viewing"
        ><em>Read more about rendering PDF.</em></a
      >
    </p>
    <h3 id="revert-a-pull-request">Revert a Pull Request</h3>
    <p>
      After a pull request is merged, you may find it does not help anything or
      it was a bad decision to merge the pull request.
    </p>
    <p>
      You can revert it by clicking the <strong>Revert</strong> button on the
      right side of a commit in the pull request page to create a pull request
      with reverted changes to this specific pull request.
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/0d3350caf2bb1cba53123ffeafc00ca702b1b164/68747470733a2f2f6769746875622d696d616765732e73332e616d617a6f6e6177732e636f6d2f68656c702f70756c6c5f72657175657374732f7265766572742d70756c6c2d726571756573742d6c696e6b2e706e67"
        alt="Revert button"
      />
      <figcaption>Revert button</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1857-introducing-the-revert-button"
        ><em>Read more about reverting pull requests</em></a
      >
    </p>
    <h3 id="diffs">Diffs</h3>
    <h4 id="rendered-prose-diffs">Rendered Prose Diffs</h4>
    <p>
      Commits and pull requests, including rendered documents supported by
      GitHub (e.g., Markdown), feature <em>source</em> and
      <em>rendered</em> views.
    </p>
    <figure>
      <img
        src="https://github-images.s3.amazonaws.com/help/repository/rendered_prose_diff.png"
        alt="Source / Rendered view"
      />
      <figcaption>Source / Rendered view</figcaption>
    </figure>
    <p>
      Click the “rendered” button to see the changes as they’ll appear in the
      rendered document. Rendered prose view is handy when you’re adding,
      removing, and editing text:
    </p>
    <figure>
      <img
        src="https://f.cloud.github.com/assets/17715/2003056/3997edb4-862b-11e3-90be-5e9586edecd7.png"
        alt="Rendered Prose Diffs"
      />
      <figcaption>Rendered Prose Diffs</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1784-rendered-prose-diffs"
        ><em>Read more about rendered prose diffs.</em></a
      >
    </p>
    <h4 id="diffable-maps">Diffable Maps</h4>
    <p>
      Any time you view a commit or pull request on GitHub that includes
      geodata, GitHub will render a visual representation of what was changed.
    </p>
    <p>
      <a
        href="https://github.com/benbalter/congressional-districts/commit/2233c76ca5bb059582d796f053775d8859198ec5"
        ><img
          src="https://f.cloud.github.com/assets/282759/2090660/63f2e45a-8e97-11e3-9d8b-d4c8078b004e.gif"
          alt="Diffable Maps"
      /></a>
    </p>
    <p>
      <a href="https://github.com/blog/1772-diffable-more-customizable-maps"
        ><em>Read more about diffable maps.</em></a
      >
    </p>
    <h4 id="expanding-context-in-diffs">Expanding Context in Diffs</h4>
    <p>
      Using the <em>unfold</em> button in the gutter of a diff, you can reveal
      additional lines of context with a click. You can keep clicking
      <em>unfold</em> until you’ve revealed the whole file, and the feature is
      available anywhere GitHub renders diffs.
    </p>
    <figure>
      <img
        src="https://f.cloud.github.com/assets/22635/1610539/863c1f64-5584-11e3-82bf-151b406a272f.gif"
        alt="Expanding Context in Diffs"
      />
      <figcaption>Expanding Context in Diffs</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1705-expanding-context-in-diffs"
        ><em>Read more about expanding context in diffs.</em></a
      >
    </p>
    <h4 id="diff-or-patch-of-pull-request">Diff or Patch of Pull Request</h4>
    <p>
      You can get the diff of a Pull Request by adding a <code>.diff</code> or
      <code>.patch</code> extension to the end of the URL. For example:
    </p>
    <pre><code>https://github.com/tiimgreen/github-cheat-sheet/pull/15
https://github.com/tiimgreen/github-cheat-sheet/pull/15.diff
https://github.com/tiimgreen/github-cheat-sheet/pull/15.patch</code></pre>
    <p>The <code>.diff</code> extension would give you this in plain text:</p>
    <pre><code>diff --git a/README.md b/README.md
index 88fcf69..8614873 100644
--- a/README.md
+++ b/README.md
@@ -28,6 +28,7 @@ All the hidden and not hidden features of Git and GitHub. This cheat sheet was i
 - [Merged Branches](#merged-branches)
 - [Quick Licensing](#quick-licensing)
 - [TODO Lists](#todo-lists)
+- [Relative Links](#relative-links)
 - [.gitconfig Recommendations](#gitconfig-recommendations)
     - [Aliases](#aliases)
     - [Auto-correct](#auto-correct)
@@ -381,6 +382,19 @@ When they are clicked, they will be updated in the pure Markdown:
 - [ ] Sleep

(...)</code></pre>
    <h4 id="rendering-and-diffing-images">Rendering and diffing images</h4>
    <p>
      GitHub can display several common image formats, including PNG, JPG, GIF,
      and PSD. In addition, there are several ways to compare differences
      between versions of those image formats.
    </p>
    <p>
      <a href="https://github.com/blog/1845-psd-viewing-diffing"
        ><img
          src="https://cloud.githubusercontent.com/assets/2546/3165594/55f2798a-eb56-11e3-92e7-b79ad791a697.gif"
          alt="Diffable PSD"
      /></a>
    </p>
    <p>
      <a href="https://help.github.com/articles/rendering-and-diffing-images/"
        ><em>Read more about rendering and diffing images.</em></a
      >
    </p>
    <h3 id="hub">Hub</h3>
    <p>
      <a href="https://github.com/github/hub">Hub</a> is a command line Git
      wrapper that gives you extra features and commands that make working with
      GitHub easier.
    </p>
    <p>This allows you to do things like:</p>
    <div class="sourceCode" id="cb26">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb26-1" title="1">$ <span class="ex">hub</span> clone tiimgreen/toc</a></code></pre>
    </div>
    <p>
      <a href="https://github.com/github/hub#commands"
        ><em>Check out some more cool commands Hub has to offer.</em></a
      >
    </p>
    <h3 id="contribution-guidelines">Contribution Guidelines</h3>
    <p>
      GitHub supports adding 3 different files which help users contribute to
      your project. These files can either be placed in the root of your
      repository or a <code>.github</code> directory under the root.
    </p>
    <h4 id="contributing-file">CONTRIBUTING File</h4>
    <p>
      Adding a <code>CONTRIBUTING</code> or <code>CONTRIBUTING.md</code> file to
      either the root of your repository or a <code>.github</code> directory
      will add a link to your file when a contributor creates an Issue or opens
      a Pull Request.
    </p>
    <figure>
      <img
        src="https://camo.githubusercontent.com/71995d6b0e620a9ef1ded00a04498241c69dd1bf/68747470733a2f2f6769746875622d696d616765732e73332e616d617a6f6e6177732e636f6d2f736b697463682f6973737565732d32303132303931332d3136323533392e6a7067"
        alt="Contributing Guidelines"
      />
      <figcaption>Contributing Guidelines</figcaption>
    </figure>
    <p>
      <a href="https://github.com/blog/1184-contributing-guidelines"
        ><em>Read more about contributing guidelines.</em></a
      >
    </p>
    <h4 id="issue_template-file">ISSUE_TEMPLATE file</h4>
    <p>
      You can define a template for all new issues opened in your project. The
      content of this file will pre-populate the new issue box when users create
      new issues. Add an <code>ISSUE_TEMPLATE</code> or
      <code>ISSUE_TEMPLATE.md</code> file to either the root of your repository
      or a <code>.github</code> directory.
    </p>
    <p>
      <a href="https://github.com/blog/2111-issue-and-pull-request-templates"
        ><em>Read more about issue templates.</em></a
      >
    </p>
    <p>
      <a href="https://www.talater.com/open-source-templates/"
        >Issue template file generator</a
      >
    </p>
    <figure>
      <img
        src="https://cloud.githubusercontent.com/assets/25792/13120859/733479fe-d564-11e5-8a1f-a03f95072f7a.png"
        alt="GitHub Issue template"
      />
      <figcaption>GitHub Issue template</figcaption>
    </figure>
    <h4 id="pull_request_template-file">PULL_REQUEST_TEMPLATE file</h4>
    <p>
      You can define a template for all new pull requests opened in your
      project. The content of this file will pre-populate the text area when
      users create pull requests. Add a <code>PULL_REQUEST_TEMPLATE</code> or
      <code>PULL_REQUEST_TEMPLATE.md</code> file to either the root of your
      repository or a <code>.github</code> directory.
    </p>
    <p>
      <a href="https://github.com/blog/2111-issue-and-pull-request-templates"
        ><em>Read more about pull request templates.</em></a
      >
    </p>
    <p>
      <a href="https://www.talater.com/open-source-templates/"
        >Pull request template file generator</a
      >
    </p>
    <h3 id="octicons">Octicons</h3>
    <p>GitHubs icons (Octicons) have now been open sourced.</p>
    <figure>
      <img
        src="https://og.github.com/octicons/octicons@1200x630.png"
        alt="Octicons"
      />
      <figcaption>Octicons</figcaption>
    </figure>
    <p>
      <a href="https://octicons.github.com"
        ><em>Read more about GitHub’s Octicons</em></a
      >
    </p>
    <h3 id="github-student-developer-pack">GitHub Student Developer Pack</h3>
    <p>
      If you are a student you will be eligible for the GitHub Student Developer
      Pack. This gives you free credit, free trials and early access to software
      that will help you when developing.
    </p>
    <figure>
      <img
        src="http://i.imgur.com/9ru3K43.png"
        alt="GitHub Student Developer Pack"
      />
      <figcaption>GitHub Student Developer Pack</figcaption>
    </figure>
    <p>
      <a href="https://education.github.com/pack"
        ><em>Read more about GitHub’s Student Developer Pack</em></a
      >
    </p>
    <h3 id="github-resources">GitHub Resources</h3>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>GitHub Explore</td>
          <td>https://github.com/explore</td>
        </tr>
        <tr class="even">
          <td>GitHub Blog</td>
          <td>https://github.com/blog</td>
        </tr>
        <tr class="odd">
          <td>GitHub Help</td>
          <td>https://help.github.com/</td>
        </tr>
        <tr class="even">
          <td>GitHub Training</td>
          <td>https://training.github.com/</td>
        </tr>
        <tr class="odd">
          <td>GitHub Developer</td>
          <td>https://developer.github.com/</td>
        </tr>
        <tr class="even">
          <td>
            Github Education (Free Micro Account and other stuff for students)
          </td>
          <td>https://education.github.com/</td>
        </tr>
        <tr class="odd">
          <td>GitHub Best Practices</td>
          <td>
            <a href="https://www.datree.io/resources/github-best-practices"
              >Best Practices List</a
            >
          </td>
        </tr>
      </tbody>
    </table>
    <h4 id="github-talks">GitHub Talks</h4>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>How GitHub Uses GitHub to Build GitHub</td>
          <td>https://www.youtube.com/watch?v=qyz3jkOBbQY</td>
        </tr>
        <tr class="even">
          <td>Introduction to Git with Scott Chacon of GitHub</td>
          <td>https://www.youtube.com/watch?v=ZDR433b0HJY</td>
        </tr>
        <tr class="odd">
          <td>How GitHub No Longer Works</td>
          <td>https://www.youtube.com/watch?v=gXD1ITW7iZI</td>
        </tr>
        <tr class="even">
          <td>Git and GitHub Secrets</td>
          <td>https://www.youtube.com/watch?v=Foz9yvMkvlA</td>
        </tr>
        <tr class="odd">
          <td>More Git and GitHub Secrets</td>
          <td>https://www.youtube.com/watch?v=p50xsL-iVgU</td>
        </tr>
      </tbody>
    </table>
    <h3 id="ssh-keys">SSH keys</h3>
    <p>
      You can get a list of public ssh keys in plain text format by visiting:
    </p>
    <pre><code>https://github.com/{user}.keys</code></pre>
    <p>
      e.g. <a href="https://github.com/tiimgreen.keys"
        >https://github.com/tiimgreen.keys</a
      >
    </p>
    <p>
      <a
        href="https://changelog.com/github-exposes-public-ssh-keys-for-its-users/"
        ><em>Read more about accessing public ssh keys.</em></a
      >
    </p>
    <h3 id="profile-image">Profile Image</h3>
    <p>You can get a user’s profile image by visiting:</p>
    <pre><code>https://github.com/{user}.png</code></pre>
    <p>
      e.g. <a href="https://github.com/tiimgreen.png"
        >https://github.com/tiimgreen.png</a
      >
    </p>
    <h3 id="repository-templates">Repository Templates</h3>
    <p>
      You can enable templating on your repository which allows anyone to copy
      the directory structure and files, allowing them to instantly use the
      files (e.g. for a tutorial or if writing boilerplate code). This can be
      enabled in the settings of your repository.
    </p>
    <figure>
      <img src="https://i.postimg.cc/hGCrVm9F/Template.gif" alt="Convert" />
      <figcaption>Convert</figcaption>
    </figure>
    <p>
      Changing to a template repository will give a new URL endpoint which can
      be shared and instantly allows users to use your repository as a template.
      Alternatively, they can go to your repository and click the ‘Use as
      template’ button.
    </p>
    <figure>
      <img
        src="https://i.postimg.cc/L8PKCHx0/New-Template.gif"
        alt="Template"
      />
      <figcaption>Template</figcaption>
    </figure>
    <p>
      <a
        href="https://github.blog/2019-06-06-generate-new-repositories-with-repository-templates/"
        ><em>Read more about using repositories as templates</em></a
      >
    </p>
    <h2 id="git">Git</h2>
    <h3 id="remove-all-deleted-files-from-the-working-tree">
      Remove All Deleted Files from the Working Tree
    </h3>
    <p>
      When you delete a lot of files using <code>/bin/rm</code> you can use the
      following command to remove them from the working tree and from the index,
      eliminating the need to remove each one individually:
    </p>
    <div class="sourceCode" id="cb29">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb29-1" title="1">$ <span class="fu">git</span> rm <span class="va">$(</span><span class="fu">git</span> ls-files -d<span class="va">)</span></a></code></pre>
    </div>
    <p>For example:</p>
    <div class="sourceCode" id="cb30">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb30-1" title="1">$ <span class="fu">git</span> status</a>
<a class="sourceLine" id="cb30-2" title="2"><span class="ex">On</span> branch master</a>
<a class="sourceLine" id="cb30-3" title="3"><span class="ex">Changes</span> not staged for commit:</a>
<a class="sourceLine" id="cb30-4" title="4">    <span class="ex">deleted</span>:    a</a>
<a class="sourceLine" id="cb30-5" title="5">    <span class="ex">deleted</span>:    c</a>
<a class="sourceLine" id="cb30-6" title="6"></a>
<a class="sourceLine" id="cb30-7" title="7">$ <span class="fu">git</span> rm <span class="va">$(</span><span class="fu">git</span> ls-files -d<span class="va">)</span></a>
<a class="sourceLine" id="cb30-8" title="8"><span class="fu">rm</span> <span class="st">&#39;a&#39;</span></a>
<a class="sourceLine" id="cb30-9" title="9"><span class="fu">rm</span> <span class="st">&#39;c&#39;</span></a>
<a class="sourceLine" id="cb30-10" title="10"></a>
<a class="sourceLine" id="cb30-11" title="11">$ <span class="fu">git</span> status</a>
<a class="sourceLine" id="cb30-12" title="12"><span class="ex">On</span> branch master</a>
<a class="sourceLine" id="cb30-13" title="13"><span class="ex">Changes</span> to be committed:</a>
<a class="sourceLine" id="cb30-14" title="14">    <span class="ex">deleted</span>:    a</a>
<a class="sourceLine" id="cb30-15" title="15">    <span class="ex">deleted</span>:    c</a></code></pre>
    </div>
    <h3 id="previous-branch">Previous Branch</h3>
    <p>To move to the previous branch in Git:</p>
    <div class="sourceCode" id="cb31">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb31-1" title="1">$ <span class="fu">git</span> checkout -</a>
<a class="sourceLine" id="cb31-2" title="2"><span class="co"># Switched to branch &#39;master&#39;</span></a>
<a class="sourceLine" id="cb31-3" title="3"></a>
<a class="sourceLine" id="cb31-4" title="4">$ <span class="fu">git</span> checkout -</a>
<a class="sourceLine" id="cb31-5" title="5"><span class="co"># Switched to branch &#39;next&#39;</span></a>
<a class="sourceLine" id="cb31-6" title="6"></a>
<a class="sourceLine" id="cb31-7" title="7">$ <span class="fu">git</span> checkout -</a>
<a class="sourceLine" id="cb31-8" title="8"><span class="co"># Switched to branch &#39;master&#39;</span></a></code></pre>
    </div>
    <p>
      <a
        href="http://git-scm.com/book/en/Git-Branching-Basic-Branching-and-Merging"
        ><em>Read more about Git branching.</em></a
      >
    </p>
    <h3 id="stripspace">Stripspace</h3>
    <p>Git Stripspace:</p>
    <ul>
      <li>Strips trailing whitespace</li>
      <li>Collapses newlines</li>
      <li>Adds newline to end of file</li>
    </ul>
    <p>A file must be passed when calling the command, e.g.:</p>
    <div class="sourceCode" id="cb32">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb32-1" title="1">$ <span class="fu">git</span> stripspace <span class="op">&lt;</span> README.md</a></code></pre>
    </div>
    <p>
      <a href="http://git-scm.com/docs/git-stripspace"
        ><em>Read more about the Git <code>stripspace</code> command.</em></a
      >
    </p>
    <h3 id="checking-out-pull-requests">Checking out Pull Requests</h3>
    <p>
      Pull Requests are special branches on the GitHub repository which can be
      retrieved locally in several ways:
    </p>
    <p>
      Retrieve a specific Pull Request and store it temporarily in
      <code>FETCH_HEAD</code> for quickly <code>diff</code>-ing or
      <code>merge</code>-ing:
    </p>
    <div class="sourceCode" id="cb33">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb33-1" title="1">$ <span class="fu">git</span> fetch origin refs/pull/[PR-Number]/head</a></code></pre>
    </div>
    <p>
      Acquire all Pull Request branches as local remote branches by refspec:
    </p>
    <div class="sourceCode" id="cb34">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb34-1" title="1">$ <span class="fu">git</span> fetch origin <span class="st">&#39;+refs/pull/*/head:refs/remotes/origin/pr/*&#39;</span></a></code></pre>
    </div>
    <p>
      Or setup the remote to fetch Pull Requests automatically by adding these
      corresponding lines in your repository’s <code>.git/config</code>:
    </p>
    <pre><code>[remote &quot;origin&quot;]
    fetch = +refs/heads/*:refs/remotes/origin/*
    url = git@github.com:tiimgreen/github-cheat-sheet.git</code></pre>
    <pre><code>[remote &quot;origin&quot;]
    fetch = +refs/heads/*:refs/remotes/origin/*
    url = git@github.com:tiimgreen/github-cheat-sheet.git
    fetch = +refs/pull/*/head:refs/remotes/origin/pr/*</code></pre>
    <p>
      For Fork-based Pull Request contributions, it’s useful to
      <code>checkout</code> a remote branch representing the Pull Request and
      create a local branch from it:
    </p>
    <div class="sourceCode" id="cb37">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb37-1" title="1">$ <span class="fu">git</span> checkout pr/42 pr-42</a></code></pre>
    </div>
    <p>
      Or should you work on more repositories, you can globally configure
      fetching pull requests in the global git config instead.
    </p>
    <div class="sourceCode" id="cb38">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb38-1" title="1"><span class="fu">git</span> config --global --add remote.origin.fetch <span class="st">&quot;+refs/pull/*/head:refs/remotes/origin/pr/*&quot;</span></a></code></pre>
    </div>
    <p>
      This way, you can use the following short commands in all your
      repositories:
    </p>
    <div class="sourceCode" id="cb39">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb39-1" title="1"><span class="fu">git</span> fetch origin</a></code></pre>
    </div>
    <div class="sourceCode" id="cb40">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb40-1" title="1"><span class="fu">git</span> checkout pr/42</a></code></pre>
    </div>
    <p>
      <a
        href="https://help.github.com/articles/checking-out-pull-requests-locally/"
        ><em>Read more about checking out pull requests locally.</em></a
      >
    </p>
    <h3 id="empty-commits">Empty Commits</h3>
    <p>
      Commits can be pushed with no code changes by adding
      <code>--allow-empty</code>:
    </p>
    <div class="sourceCode" id="cb41">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb41-1" title="1">$ <span class="fu">git</span> commit -m <span class="st">&quot;Big-ass commit&quot;</span> --allow-empty</a></code></pre>
    </div>
    <p>Some use-cases for this (that make sense), include:</p>
    <ul>
      <li>Annotating the start of a new bulk of work or a new feature.</li>
      <li>
        Documenting when you make changes to the project that aren’t code
        related.
      </li>
      <li>Communicating with people using your repository.</li>
      <li>
        The first commit of a repository:
        <code>git commit -m "Initial commit" --allow-empty</code>.
      </li>
    </ul>
    <h3 id="styled-git-status">Styled Git Status</h3>
    <p>Running:</p>
    <div class="sourceCode" id="cb42">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb42-1" title="1">$ <span class="fu">git</span> status</a></code></pre>
    </div>
    <p>produces:</p>
    <figure>
      <img src="http://i.imgur.com/qjPyvXb.png" alt="git status" />
      <figcaption>git status</figcaption>
    </figure>
    <p>By adding <code>-sb</code>:</p>
    <div class="sourceCode" id="cb43">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb43-1" title="1">$ <span class="fu">git</span> status -sb</a></code></pre>
    </div>
    <p>this is produced:</p>
    <figure>
      <img src="http://i.imgur.com/K0OY3nm.png" alt="git status -sb" />
      <figcaption>git status -sb</figcaption>
    </figure>
    <p>
      <a href="http://git-scm.com/docs/git-status"
        ><em>Read more about the Git <code>status</code> command.</em></a
      >
    </p>
    <h3 id="styled-git-log">Styled Git Log</h3>
    <p>Running:</p>
    <div class="sourceCode" id="cb44">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb44-1" title="1">$ <span class="fu">git</span> log --all --graph --pretty=format:<span class="st">&#39;%Cred%h%Creset -%C(auto)%d%Creset %s %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset&#39;</span> --abbrev-commit --date=relative</a></code></pre>
    </div>
    <p>produces:</p>
    <figure>
      <img
        src="http://i.imgur.com/58eOtkW.png"
        alt="git log –all –graph –pretty=format:‘%Cred%h%Creset -%C(auto)%d%Creset %s %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset’ –abbrev-commit –date=relative"
      />
      <figcaption>
        git log –all –graph –pretty=format:‘%Cred%h%Creset -%C(auto)%d%Creset %s
        %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset’ –abbrev-commit
        –date=relative
      </figcaption>
    </figure>
    <p>
      Credit to <a href="http://stackoverflow.com/users/88355/palesz">Palesz</a>
    </p>
    <p>
      <em
        >This can be aliased using the instructions found
        <a href="https://github.com/tiimgreen/github-cheat-sheet#aliases"
          >here</a
        >.</em
      >
    </p>
    <p>
      <a href="http://git-scm.com/docs/git-log"
        ><em>Read more about the Git <code>log</code> command.</em></a
      >
    </p>
    <h3 id="git-query">Git Query</h3>
    <p>
      A Git query allows you to search all your previous commit messages and
      find the most recent one matching the query.
    </p>
    <div class="sourceCode" id="cb45">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb45-1" title="1">$ <span class="fu">git</span> show :/query</a></code></pre>
    </div>
    <p>
      where <code>query</code> (case-sensitive) is the term you want to search,
      this then finds the last one and gives details on the lines that were
      changed.
    </p>
    <div class="sourceCode" id="cb46">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb46-1" title="1">$ <span class="fu">git</span> show :/typo</a></code></pre>
    </div>
    <figure>
      <img src="http://i.imgur.com/icaGiNt.png" alt="git show :/query" />
      <figcaption>git show :/query</figcaption>
    </figure>
    <p>
      <em>Press <code>q</code> to quit.</em>
    </p>
    <h3 id="git-grep">Git Grep</h3>
    <p>Git Grep will return a list of lines matching a pattern.</p>
    <p>Running:</p>
    <div class="sourceCode" id="cb47">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb47-1" title="1">$ <span class="fu">git</span> grep aliases</a></code></pre>
    </div>
    <p>will show all the files containing the string <em>aliases</em>.</p>
    <figure>
      <img src="http://i.imgur.com/DL2zpQ9.png" alt="git grep aliases" />
      <figcaption>git grep aliases</figcaption>
    </figure>
    <p>
      <em>Press <code>q</code> to quit.</em>
    </p>
    <p>
      You can also use multiple flags for more advanced search. For example:
    </p>
    <ul>
      <li><code>-e</code> The next parameter is the pattern (e.g., regex)</li>
      <li>
        <code>--and</code>, <code>--or</code> and <code>--not</code> Combine
        multiple patterns.
      </li>
    </ul>
    <p>Use it like this:</p>
    <div class="sourceCode" id="cb48">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb48-1" title="1"> $ <span class="fu">git</span> grep -e pattern --and -e anotherpattern</a></code></pre>
    </div>
    <p>
      <a href="http://git-scm.com/docs/git-grep"
        ><em>Read more about the Git <code>grep</code> command.</em></a
      >
    </p>
    <h3 id="merged-branches">Merged Branches</h3>
    <p>Running:</p>
    <div class="sourceCode" id="cb49">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb49-1" title="1">$ <span class="fu">git</span> branch --merged</a></code></pre>
    </div>
    <p>
      will give you a list of all branches that have been merged into your
      current branch.
    </p>
    <p>Conversely:</p>
    <div class="sourceCode" id="cb50">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb50-1" title="1">$ <span class="fu">git</span> branch --no-merged</a></code></pre>
    </div>
    <p>
      will give you a list of branches that have not been merged into your
      current branch.
    </p>
    <p>
      <a href="http://git-scm.com/docs/git-branch"
        ><em>Read more about the Git <code>branch</code> command.</em></a
      >
    </p>
    <h3 id="fixup-and-autosquash">Fixup and Autosquash</h3>
    <p>
      If there is something wrong with a previous commit (can be one or more
      from HEAD), for example <code>abcde</code>, run the following command
      after you’ve amended the problem:
    </p>
    <div class="sourceCode" id="cb51">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb51-1" title="1">$ <span class="fu">git</span> commit --fixup=abcde</a>
<a class="sourceLine" id="cb51-2" title="2">$ <span class="fu">git</span> rebase abcde^ --autosquash -i</a></code></pre>
    </div>
    <p>
      <a href="http://git-scm.com/docs/git-commit"
        ><em>Read more about the Git <code>commit</code> command.</em></a
      >
      <a href="http://git-scm.com/docs/git-rebase"
        ><em>Read more about the Git <code>rebase</code> command.</em></a
      >
    </p>
    <h3 id="web-server-for-browsing-local-repositories">
      Web Server for Browsing Local Repositories
    </h3>
    <p>
      Use the Git <code>instaweb</code> command to instantly browse your working
      repository in <code>gitweb</code>. This command is a simple script to set
      up <code>gitweb</code> and a web server for browsing the local repository.
    </p>
    <div class="sourceCode" id="cb52">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb52-1" title="1">$ <span class="fu">git</span> instaweb</a></code></pre>
    </div>
    <p>opens:</p>
    <figure>
      <img src="http://i.imgur.com/Dxekmqc.png" alt="Git instaweb" />
      <figcaption>Git instaweb</figcaption>
    </figure>
    <p>
      <a href="http://git-scm.com/docs/git-instaweb"
        ><em>Read more about the Git <code>instaweb</code> command.</em></a
      >
    </p>
    <h3 id="git-configurations">Git Configurations</h3>
    <p>
      Your <code>.gitconfig</code> file contains all your Git configurations.
    </p>
    <h4 id="aliases">Aliases</h4>
    <p>
      Aliases are helpers that let you define your own git calls. For example
      you could set <code>git a</code> to run <code>git add --all</code>.
    </p>
    <p>
      To add an alias, either navigate to <code>~/.gitconfig</code> and fill it
      out in the following format:
    </p>
    <pre><code>[alias]
  co = checkout
  cm = commit
  p = push
  # Show verbose output about tags, branches or remotes
  tags = tag -l
  branches = branch -a
  remotes = remote -v</code></pre>
    <p>…or type in the command-line:</p>
    <div class="sourceCode" id="cb54">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb54-1" title="1">$ <span class="fu">git</span> config --global alias.new_alias git_function</a></code></pre>
    </div>
    <p>For example:</p>
    <div class="sourceCode" id="cb55">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb55-1" title="1">$ <span class="fu">git</span> config --global alias.cm commit</a></code></pre>
    </div>
    <p>For an alias with multiple functions use quotes:</p>
    <div class="sourceCode" id="cb56">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb56-1" title="1">$ <span class="fu">git</span> config --global alias.ac <span class="st">&#39;add -A . &amp;&amp; commit&#39;</span></a></code></pre>
    </div>
    <p>Some useful aliases include:</p>
    <table>
      <colgroup>
        <col style="width: 33%" />
        <col style="width: 33%" />
        <col style="width: 33%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Alias</th>
          <th>Command</th>
          <th>What to Type</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>git cm</code></td>
          <td><code>git commit</code></td>
          <td><code>git config --global alias.cm commit</code></td>
        </tr>
        <tr class="even">
          <td><code>git co</code></td>
          <td><code>git checkout</code></td>
          <td><code>git config --global alias.co checkout</code></td>
        </tr>
        <tr class="odd">
          <td><code>git ac</code></td>
          <td><code>git add . -A</code> <code>git commit</code></td>
          <td>
            <code
              >git config --global alias.ac '!git add -A &amp;&amp; git
              commit'</code
            >
          </td>
        </tr>
        <tr class="even">
          <td><code>git st</code></td>
          <td><code>git status -sb</code></td>
          <td><code>git config --global alias.st 'status -sb'</code></td>
        </tr>
        <tr class="odd">
          <td><code>git tags</code></td>
          <td><code>git tag -l</code></td>
          <td><code>git config --global alias.tags 'tag -l'</code></td>
        </tr>
        <tr class="even">
          <td><code>git branches</code></td>
          <td><code>git branch -a</code></td>
          <td><code>git config --global alias.branches 'branch -a'</code></td>
        </tr>
        <tr class="odd">
          <td><code>git cleanup</code></td>
          <td>
            <code
              >git branch --merged \| grep -v '*' \| xargs git branch -d</code
            >
          </td>
          <td>
            <code
              >git config --global alias.cleanup "!git branch --merged \| grep
              -v '*' \| xargs git branch -d"</code
            >
          </td>
        </tr>
        <tr class="even">
          <td><code>git remotes</code></td>
          <td><code>git remote -v</code></td>
          <td><code>git config --global alias.remotes 'remote -v'</code></td>
        </tr>
        <tr class="odd">
          <td><code>git lg</code></td>
          <td>
            <code
              >git log --color --graph --pretty=format:'%Cred%h%Creset
              -%C(yellow)%d%Creset %s %Cgreen(%cr) %C(bold
              blue)&lt;%an&gt;%Creset' --abbrev-commit --</code
            >
          </td>
          <td>
            <code
              >git config --global alias.lg "log --color --graph
              --pretty=format:'%Cred%h%Creset -%C(yellow)%d%Creset %s
              %Cgreen(%cr) %C(bold blue)&lt;%an&gt;%Creset' --abbrev-commit
              --"</code
            >
          </td>
        </tr>
      </tbody>
    </table>
    <p>
      <em
        >Some Aliases are taken from
        <span class="citation" data-cites="mathiasbynens">[@mathiasbynens]</span
        >(https://github.com/mathiasbynens) dotfiles:
        https://github.com/mathiasbynens/dotfiles/blob/master/.gitconfig</em
      >
    </p>
    <h4 id="auto-correct">Auto-Correct</h4>
    <p>
      Git gives suggestions for misspelled commands and if auto-correct is
      enabled the command can be fixed and executed automatically. Auto-correct
      is enabled by specifying an integer which is the delay in tenths of a
      second before git will run the corrected command. Zero is the default
      value where no correcting will take place, and a negative value will run
      the corrected command with no delay.
    </p>
    <p>For example, if you type <code>git comit</code> you will get this:</p>
    <div class="sourceCode" id="cb57">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb57-1" title="1">$ <span class="fu">git</span> comit -m <span class="st">&quot;Message&quot;</span></a>
<a class="sourceLine" id="cb57-2" title="2"><span class="co"># git: &#39;comit&#39; is not a git command. See &#39;git --help&#39;.</span></a>
<a class="sourceLine" id="cb57-3" title="3"></a>
<a class="sourceLine" id="cb57-4" title="4"><span class="co"># Did you mean this?</span></a>
<a class="sourceLine" id="cb57-5" title="5"><span class="co">#   commit</span></a></code></pre>
    </div>
    <p>Auto-correct can be enabled like this (with a 1.5 second delay):</p>
    <div class="sourceCode" id="cb58">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb58-1" title="1">$ <span class="fu">git</span> config --global help.autocorrect 15</a></code></pre>
    </div>
    <p>
      So now the command <code>git comit</code> will be auto-corrected to
      <code>git commit</code> like this:
    </p>
    <div class="sourceCode" id="cb59">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb59-1" title="1">$ <span class="fu">git</span> comit -m <span class="st">&quot;Message&quot;</span></a>
<a class="sourceLine" id="cb59-2" title="2"><span class="co"># </span><span class="al">WARNING</span><span class="co">: You called a Git command named &#39;comit&#39;, which does not exist.</span></a>
<a class="sourceLine" id="cb59-3" title="3"><span class="co"># Continuing under the assumption that you meant &#39;commit&#39;</span></a>
<a class="sourceLine" id="cb59-4" title="4"><span class="co"># in 1.5 seconds automatically...</span></a></code></pre>
    </div>
    <p>
      The delay before git will rerun the command is so the user has time to
      abort.
    </p>
    <h4 id="color">Color</h4>
    <p>To add more color to your Git output:</p>
    <div class="sourceCode" id="cb60">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb60-1" title="1">$ <span class="fu">git</span> config --global color.ui 1</a></code></pre>
    </div>
    <p>
      <a href="http://git-scm.com/docs/git-config"
        ><em>Read more about the Git <code>config</code> command.</em></a
      >
    </p>
    <h3 id="git-resources">Git Resources</h3>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>Official Git Site</td>
          <td>http://git-scm.com/</td>
        </tr>
        <tr class="even">
          <td>Official Git Video Tutorials</td>
          <td>http://git-scm.com/videos</td>
        </tr>
        <tr class="odd">
          <td>Code School Try Git</td>
          <td>http://try.github.com/</td>
        </tr>
        <tr class="even">
          <td>Introductory Reference &amp; Tutorial for Git</td>
          <td>http://gitref.org/</td>
        </tr>
        <tr class="odd">
          <td>Official Git Tutorial</td>
          <td>http://git-scm.com/docs/gittutorial</td>
        </tr>
        <tr class="even">
          <td>Everyday Git</td>
          <td>http://git-scm.com/docs/everyday</td>
        </tr>
        <tr class="odd">
          <td>Git Immersion</td>
          <td>http://gitimmersion.com/</td>
        </tr>
        <tr class="even">
          <td>Git God</td>
          <td>https://github.com/gorosgobe/git-god</td>
        </tr>
        <tr class="odd">
          <td>Git for Computer Scientists</td>
          <td>http://eagain.net/articles/git-for-computer-scientists/</td>
        </tr>
        <tr class="even">
          <td>Git Magic</td>
          <td>http://www-cs-students.stanford.edu/~blynn/gitmagic/</td>
        </tr>
        <tr class="odd">
          <td>Git Visualization Playground</td>
          <td>http://onlywei.github.io/explain-git-with-d3/#freeplay</td>
        </tr>
        <tr class="even">
          <td>Learn Git Branching</td>
          <td>http://pcottle.github.io/learnGitBranching/</td>
        </tr>
        <tr class="odd">
          <td>A collection of useful .gitignore templates</td>
          <td>https://github.com/github/gitignore</td>
        </tr>
        <tr class="even">
          <td>Unixorn’s git-extra-commands collection of git scripts</td>
          <td>https://github.com/unixorn/git-extra-commands</td>
        </tr>
      </tbody>
    </table>
    <h4 id="git-books">Git Books</h4>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>Pragmatic Version Control Using Git</td>
          <td>
            https://pragprog.com/titles/tsgit/pragmatic-version-control-using-git
          </td>
        </tr>
        <tr class="even">
          <td>Pro Git</td>
          <td>http://git-scm.com/book</td>
        </tr>
        <tr class="odd">
          <td>Git Internals PluralSight</td>
          <td>https://github.com/pluralsight/git-internals-pdf</td>
        </tr>
        <tr class="even">
          <td>Git in the Trenches</td>
          <td>http://cbx33.github.io/gitt/</td>
        </tr>
        <tr class="odd">
          <td>Version Control with Git</td>
          <td>
            http://www.amazon.com/Version-Control-Git-collaborative-development/dp/1449316387
          </td>
        </tr>
        <tr class="even">
          <td>Pragmatic Guide to Git</td>
          <td>https://pragprog.com/titles/pg_git/pragmatic-guide-to-git</td>
        </tr>
        <tr class="odd">
          <td>Git: Version Control for Everyone</td>
          <td>
            https://www.packtpub.com/application-development/git-version-control-everyone
          </td>
        </tr>
      </tbody>
    </table>
    <h4 id="git-videos">Git Videos</h4>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>Linus Torvalds on Git</td>
          <td>https://www.youtube.com/watch?v=4XpnKHJAok8</td>
        </tr>
        <tr class="even">
          <td>Introduction to Git with Scott Chacon</td>
          <td>https://www.youtube.com/watch?v=ZDR433b0HJY</td>
        </tr>
        <tr class="odd">
          <td>Git From the Bits Up</td>
          <td>https://www.youtube.com/watch?v=MYP56QJpDr4</td>
        </tr>
        <tr class="even">
          <td>Graphs, Hashes, and Compression, Oh My!</td>
          <td>https://www.youtube.com/watch?v=ig5E8CcdM9g</td>
        </tr>
        <tr class="odd">
          <td>GitHub Training &amp; Guides</td>
          <td>
            https://www.youtube.com/watch?list=PLg7s6cbtAD15G8lNyoaYDuKZSKyJrgwB-&amp;v=FyfwLX4HAxM
          </td>
        </tr>
      </tbody>
    </table>
    <h4 id="git-articles">Git Articles</h4>
    <table>
      <colgroup>
        <col style="width: 55%" />
        <col style="width: 44%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Title</th>
          <th>Link</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>GitHub Flow</td>
          <td>http://scottchacon.com/2011/08/31/github-flow.html</td>
        </tr>
        <tr class="even">
          <td>Migrating to Git Large File Storate (Git LFS)</td>
          <td>
            http://vooban.com/en/tips-articles-geek-stuff/migrating-to-git-lfs-for-developing-deep-learning-applications-with-large-files/
          </td>
        </tr>
      </tbody>
    </table>
  </body>
</html>
